<template>
  <div class="address-input">
    <phone-number-input
      v-bind="$attrs"
      label="Telefone para contato"
      v-model="phoneNumber"
     />    <phone-number-input
      v-bind="$attrs"
      label="Telefone para emergência"
      v-model="emergencyPhoneNumber"
     />    <v-text-field
      v-bind="$attrs"
      label="Nome de contato de emergência"
      v-model="emergencyContactName"
     />  </div>

</template>

<script lang="ts">
import Vue from 'vue'

import PhoneNumberInput from '@/components/input/PhoneNumber.vue'

import vRequired from '@/validators/required'

export default Vue.extend({
  name: 'ContactInput',
  components: {
    PhoneNumberInput
  },
  props: {
    value: { type: Object, default: null }
  },
  data: (): {
    phoneNumber: string | null,
    emergencyPhoneNumber: string | null,
    emergencyContactName: string | null,
    vRequired: Function
  } => ({
    phoneNumber: null,
    emergencyPhoneNumber: null,
    emergencyContactName: null,

    vRequired
  }),
  watch: {
    value () {
      if (this.value === null) {
        this.phoneNumber = null
        this.emergencyPhoneNumber = null
        this.emergencyContactName = null
      }
    },
    phoneNumber () {
      this.updated()
    },
    emergencyPhoneNumber () {
      this.updated()
    },
    emergencyContactName () {
      this.updated()
    }
  },
  methods: {
    updated () {
      this.$emit('input', {
        phoneNumber: this.phoneNumber,
        emergencyPhoneNumber: this.emergencyPhoneNumber,
        emergencyContactName: this.emergencyContactName
      })
    }
  }
})
</script>

<style lang="scss" scoped>
.document-type {
  width: 10em;
}
</style>
